/* A Bison parser, made from parser.y, by GNU bison 1.75.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON	1

/* Pure parsers.  */
#define YYPURE	0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     CLASS = 258,
     DOCUMENTATION = 259,
     IDENT = 260,
     MACRONAME = 261,
     TEMPLATE = 262,
     PATH = 263,
     DISABLE = 264,
     LCURLYBK = 265,
     RCURLYBK = 266,
     LSQBK = 267,
     RSQBK = 268,
     LPAREN = 269,
     RPAREN = 270,
     INHERIT = 271,
     FATHERREL = 272,
     MINUS = 273,
     PLUS = 274,
     XPLUS = 275,
     STAR = 276,
     NEG = 277,
     PREC = 278,
     ANCESTOR = 279,
     COMMA = 280,
     COLON = 281,
     SEMICOLON = 282,
     DOUBLECOLON = 283,
     EQUAL = 284,
     XEQUAL = 285,
     DOT = 286,
     ALT = 287,
     JOIN = 288,
     BANG = 289,
     IMP = 290,
     EQUIV = 291,
     DESC = 292,
     NODE = 293,
     OPT = 294,
     VALUE = 295,
     VAR = 296,
     FATHER = 297
   };
#endif
#define CLASS 258
#define DOCUMENTATION 259
#define IDENT 260
#define MACRONAME 261
#define TEMPLATE 262
#define PATH 263
#define DISABLE 264
#define LCURLYBK 265
#define RCURLYBK 266
#define LSQBK 267
#define RSQBK 268
#define LPAREN 269
#define RPAREN 270
#define INHERIT 271
#define FATHERREL 272
#define MINUS 273
#define PLUS 274
#define XPLUS 275
#define STAR 276
#define NEG 277
#define PREC 278
#define ANCESTOR 279
#define COMMA 280
#define COLON 281
#define SEMICOLON 282
#define DOUBLECOLON 283
#define EQUAL 284
#define XEQUAL 285
#define DOT 286
#define ALT 287
#define JOIN 288
#define BANG 289
#define IMP 290
#define EQUIV 291
#define DESC 292
#define NODE 293
#define OPT 294
#define VALUE 295
#define VAR 296
#define FATHER 297




/* Copy the first part of user declarations.  */
#line 1 "parser.y"

#include <stdio.h>
#define YYSTYPE char*
extern int yylex();
extern unsigned yylineno;

#include "libxml/tree.h"
extern xmlDocPtr document_xml ;
extern xmlNodePtr MetaGrammar ;
extern xmlNodePtr CurrentClass ;
extern int class_found ;
extern int error_symb ;
extern int keep_comments;

#include "hash.h"
#include "symbol.h"

//#define DEBUGYACC 0
#ifdef DEBUGYACC
#define DBUGYACC(x) x
#else
#define DBUGYACC(x)
#endif

#define MALLOCERROR(xxxx) {printf("malloc_error:\t%s (line number: %d)\n",xxxx,yylineno);exit(-1);}

char * cp_str (char * str1, char * str2) {
  char * new_str ;
  if (str1 == NULL) return (str2) ;
  if (str2 == NULL) return (str1) ;
  new_str = (char*) calloc(strlen(str1)+strlen(str2)+1,sizeof (char)) ;
  sprintf (new_str, "%s%s", str1, str2) ;
  free (str1); free(str2) ;
  return (new_str) ;
}

unsigned char * xmlstrdup (unsigned char * in) {
    unsigned char *out;
    int ret,size,out_size,temp;
    xmlCharEncodingHandlerPtr handler;
    
    size = (int)strlen(in)+1; 
    out_size = size*2-1; 
    out = malloc((size_t)out_size); 

    if (out) {
        handler = xmlFindCharEncodingHandler("iso-8859-1") ;
        if (!handler) {
            free (out);
            out = NULL;
	    printf ("xmlstrdup: no handler\n") ; exit (1) ;
        }
    }
    if (out) {
      temp=size-1;
      ret = handler->input(out, &out_size, in, &temp);
      if ((ret < 0) || (temp-size+1)) {
	if (ret < 0) {
	  printf ("xmlstrdup: conversion wasn't successful.\n");
	}
	else {
	  printf ("xmlstrdup: conversion wasn't successful. converted: %i octets.\n", temp);
	}
	free (out);
	out = NULL;
	exit (1) ;
      }
      else {
	out = realloc(out,out_size+1); 
	out[out_size]=0; /*null terminating out*/
      }
    }
    else {
      MALLOCERROR ("xmlstrdup") ;
    }
    return (out);
}
 
 


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#ifndef YYSTYPE
typedef int yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif

#ifndef YYLTYPE
typedef struct yyltype
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} yyltype;
# define YYLTYPE yyltype
# define YYLTYPE_IS_TRIVIAL 1
#endif

/* Copy the second part of user declarations.  */


/* Line 213 of /usr/share/bison/yacc.c.  */
#line 258 "parser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];	\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  9
#define YYLAST   167

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  43
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  41
/* YYNRULES -- Number of rules. */
#define YYNRULES  90
/* YYNRULES -- Number of states. */
#define YYNSTATES  164

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   297

#define YYTRANSLATE(X) \
  ((unsigned)(X) <= YYMAXUTOK ? yytranslate[X] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     6,     8,    11,    13,    14,    15,    16,
      28,    29,    36,    37,    44,    48,    51,    52,    55,    60,
      63,    65,    67,    69,    71,    73,    75,    77,    79,    81,
      83,    85,    87,    90,    94,    98,   102,   106,   113,   114,
     116,   120,   124,   128,   133,   137,   141,   143,   147,   149,
     153,   155,   159,   163,   167,   170,   174,   177,   182,   185,
     187,   191,   193,   195,   197,   199,   201,   205,   207,   210,
     212,   216,   218,   222,   224,   227,   229,   232,   236,   237,
     241,   245,   247,   252,   257,   259,   262,   265,   267,   271,
     272
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      44,     0,    -1,    45,    83,    -1,    46,    -1,    45,    46,
      -1,     1,    -1,    -1,    -1,    -1,    83,     3,     5,    47,
      83,    48,    10,    83,    49,    52,    11,    -1,    -1,    83,
       7,     6,    50,    29,    74,    -1,    -1,    83,     8,     6,
      51,    29,    78,    -1,    83,     9,     5,    -1,     1,    11,
      -1,    -1,    53,    83,    -1,    53,    27,    83,    52,    -1,
       1,    27,    -1,    54,    -1,    55,    -1,    56,    -1,    57,
      -1,    58,    -1,    59,    -1,    68,    -1,    75,    -1,    80,
      -1,    81,    -1,    62,    -1,    67,    -1,    16,     5,    -1,
      82,    17,    82,    -1,    82,    24,    82,    -1,    82,    23,
      82,    -1,    82,    29,    82,    -1,    37,    14,    12,    60,
      13,    15,    -1,    -1,    61,    -1,    60,    25,    61,    -1,
       5,    26,    74,    -1,    82,    35,    63,    -1,    22,    82,
      35,    63,    -1,    82,    19,    63,    -1,    82,    20,    63,
      -1,    64,    -1,    63,    32,    64,    -1,    66,    -1,    65,
      25,    66,    -1,    66,    -1,    65,    25,    66,    -1,    69,
      29,    69,    -1,    69,    30,    69,    -1,    34,    69,    -1,
      69,    29,    69,    -1,    79,    78,    -1,    40,    14,    74,
      15,    -1,    41,    82,    -1,    72,    -1,    72,    32,    71,
      -1,     5,    -1,    21,    -1,    19,    -1,    18,    -1,    72,
      -1,    72,    32,    71,    -1,    73,    -1,    22,    73,    -1,
      70,    -1,    70,    33,    74,    -1,     6,    -1,    12,    60,
      13,    -1,    76,    -1,    39,    76,    -1,    77,    -1,    38,
      77,    -1,    82,    26,    74,    -1,    -1,    31,     5,    78,
      -1,    31,     6,    78,    -1,    37,    -1,    42,    14,    82,
      15,    -1,    38,    14,    82,    15,    -1,    70,    -1,    18,
      82,    -1,    19,    82,    -1,     5,    -1,    82,    28,     5,
      -1,    -1,     4,    83,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    93,    93,   102,   105,   106,   109,   121,   129,   108,
     142,   141,   158,   157,   173,   184,   186,   187,   198,   209,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   224,   233,   243,   253,   263,   273,   284,   290,
     298,   307,   317,   326,   335,   348,   363,   370,   377,   378,
     385,   391,   399,   407,   418,   426,   438,   445,   453,   460,
     466,   474,   480,   486,   490,   495,   496,   504,   505,   511,
     515,   521,   527,   532,   533,   540,   546,   553,   564,   569,
     578,   589,   594,   600,   606,   609,   617,   625,   629,   639,
     640
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "CLASS", "DOCUMENTATION", "IDENT", 
  "MACRONAME", "TEMPLATE", "PATH", "DISABLE", "LCURLYBK", "RCURLYBK", 
  "LSQBK", "RSQBK", "LPAREN", "RPAREN", "INHERIT", "FATHERREL", "MINUS", 
  "PLUS", "XPLUS", "STAR", "NEG", "PREC", "ANCESTOR", "COMMA", "COLON", 
  "SEMICOLON", "DOUBLECOLON", "EQUAL", "XEQUAL", "DOT", "ALT", "JOIN", 
  "BANG", "IMP", "EQUIV", "DESC", "NODE", "OPT", "VALUE", "VAR", "FATHER", 
  "$accept", "Axiom", "Dcllist", "Dcl", "@1", "@2", "@3", "@4", "@5", 
  "Proplist", "Property", "Heritage", "Pere", "Ancetre", "Precedence", 
  "Equality", "Desc", "Features", "F", "Guard", "EqAlt", "EqSeq", 
  "EqSeq1", "EqElem", "Atomic", "Equation", "EqTerm", "Varname", 
  "AtomAlts", "Atom", "NValue", "Value", "Node", "VNode", "RawNode", 
  "Path", "RootOfPath", "Needs", "Provides", "Idname", "Doc", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    43,    44,    45,    45,    45,    47,    48,    49,    46,
      50,    46,    51,    46,    46,    46,    52,    52,    52,    52,
      53,    53,    53,    53,    53,    53,    53,    53,    53,    53,
      53,    53,    54,    55,    56,    57,    58,    59,    60,    60,
      60,    61,    62,    62,    62,    62,    63,    63,    64,    64,
      65,    65,    66,    66,    67,    68,    69,    69,    70,    71,
      71,    72,    72,    72,    72,    73,    73,    74,    74,    74,
      74,    74,    74,    75,    75,    76,    76,    77,    78,    78,
      78,    79,    79,    79,    79,    80,    81,    82,    82,    83,
      83
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     1,     2,     1,     0,     0,     0,    11,
       0,     6,     0,     6,     3,     2,     0,     2,     4,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     3,     3,     3,     6,     0,     1,
       3,     3,     3,     4,     3,     3,     1,     3,     1,     3,
       1,     3,     3,     3,     2,     3,     2,     4,     2,     1,
       3,     1,     1,     1,     1,     1,     3,     1,     2,     1,
       3,     1,     3,     1,     2,     1,     2,     3,     0,     3,
       3,     1,     4,     4,     1,     2,     2,     1,     3,     0,
       2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     5,    89,     0,     0,     3,     0,    15,    90,     1,
       0,     4,     2,     0,     0,     0,     0,     6,    10,    12,
      14,    89,     0,     0,     7,     0,    78,     0,    61,    71,
      38,    64,    63,    62,     0,     0,    69,    65,    67,    11,
       0,    13,    89,     0,     0,    39,    68,    87,    58,     0,
       0,    78,    78,     8,     0,    72,     0,     0,    70,    66,
      59,    79,    80,     0,    41,    40,    88,     0,     0,     0,
       0,     0,     0,     0,    81,     0,     0,     0,     0,     0,
      89,    20,    21,    22,    23,    24,    25,    30,    31,    26,
       0,    84,    27,    73,    75,    78,    28,    29,     0,    60,
      19,    32,    85,    86,     0,    81,     0,    54,     0,     0,
      76,     0,     0,    74,     0,     0,     9,    89,    17,     0,
      56,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      38,     0,     0,     0,     0,    55,    33,    44,    46,     0,
      48,     0,    45,    35,    34,    77,    36,    42,    43,     0,
      83,    57,    82,    18,     0,     0,     0,     0,     0,    47,
      49,    52,    53,    37
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     3,     4,     5,    21,    27,    63,    22,    23,    79,
      80,    81,    82,    83,    84,    85,    86,    44,    45,    87,
     137,   138,   139,   140,    88,    89,   141,    91,    59,    37,
      38,    39,    92,    93,    94,    41,    95,    96,    97,   111,
       6
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -68
static const short yypact[] =
{
     127,    10,    42,    52,    67,   -68,    80,   -68,   -68,   -68,
      10,   -68,    80,    59,    63,    71,    60,   -68,   -68,   -68,
     -68,    42,    44,    50,   -68,    88,    51,    75,   -68,   -68,
      86,   -68,   -68,   -68,     8,    92,    66,    69,   -68,   -68,
      57,   -68,    42,    96,    35,   -68,   -68,   -68,    99,    88,
       8,    51,    51,   -68,    88,   -68,    86,   103,   -68,   -68,
     101,   -68,   -68,    17,   -68,   -68,   -68,     8,   112,   119,
      92,    92,    92,   100,   129,    39,     0,   130,   131,   135,
       5,   -68,   -68,   -68,   -68,   -68,   -68,   -68,   -68,   -68,
     118,   -68,   -68,   -68,   -68,    51,   -68,   -68,    97,   -68,
     -68,   -68,    99,    99,   -12,   -68,   134,   -68,   137,    92,
     -68,   -11,    92,   -68,    88,    92,   -68,    42,   -68,   100,
     -68,    92,   100,   100,    92,    92,    88,    92,   100,   100,
      86,    -4,   136,    22,    17,   -68,    99,   120,   -68,   125,
     128,    82,   120,    99,    99,   -68,    99,   120,   120,    36,
     -68,   -68,   -68,   -68,   100,   100,   100,   100,   139,   -68,
     132,   -68,   -68,   -68
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
     -68,   -68,   -68,   151,   -68,   -68,   -68,   -68,   -68,    24,
     -68,   -68,   -68,   -68,   -68,   -68,   -68,    26,   104,   -68,
     -10,     7,   -68,     4,   -68,   -68,   -53,   -24,    95,   -36,
     133,   -42,   -68,    87,   -67,   -48,   -68,   -68,   -68,   -29,
      -2
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, parse error.  */
#define YYTABLE_NINF -90
static const short yytable[] =
{
       8,    36,    12,    61,    62,    47,    48,    58,   110,     2,
      90,   150,    64,    28,    60,   126,    57,    57,    68,    24,
     107,     7,    47,   129,    57,    36,    31,    32,   -16,    33,
      36,    60,   117,    69,    98,    70,    71,   152,   112,    72,
      53,   102,   103,   104,    47,   110,     2,   120,    55,   158,
      57,    73,     9,   109,    74,    75,    76,    77,    35,    78,
      56,    56,    51,    52,    17,    20,   135,   -89,    10,    18,
     -89,     2,   132,    25,   -89,   -89,   -89,    19,   118,    26,
     131,    90,    40,    13,   145,    42,   133,    14,    15,    16,
      36,    43,   136,    28,    29,   143,   144,    47,   146,    49,
      30,    50,    36,   161,   162,    98,    31,    32,    66,    33,
      34,   156,   157,   142,   121,   134,   122,   123,   147,   148,
     124,   125,    54,   126,   101,    57,   127,    57,     1,    35,
     -89,     2,   128,    67,   -89,   -89,   -89,   105,   106,   100,
      77,    35,    78,   108,   114,   115,   116,   119,   109,   130,
     155,   151,   154,   -50,   163,    11,   149,   -51,   153,   160,
      65,   159,    99,   113,     0,     0,     0,    46
};

static const short yycheck[] =
{
       2,    25,     4,    51,    52,     5,    35,    49,    75,     4,
      63,    15,    54,     5,    50,    26,    28,    28,     1,    21,
      73,    11,     5,    35,    28,    49,    18,    19,    11,    21,
      54,    67,    27,    16,    63,    18,    19,    15,    38,    22,
      42,    70,    71,    72,     5,   112,     4,    95,    13,    13,
      28,    34,     0,    14,    37,    38,    39,    40,    41,    42,
      25,    25,     5,     6,     5,     5,   119,     0,     1,     6,
       3,     4,   114,    29,     7,     8,     9,     6,    80,    29,
     109,   134,    31,     3,   126,    10,   115,     7,     8,     9,
     114,     5,   121,     5,     6,   124,   125,     5,   127,    33,
      12,    32,   126,   156,   157,   134,    18,    19,     5,    21,
      22,    29,    30,   123,    17,   117,    19,    20,   128,   129,
      23,    24,    26,    26,     5,    28,    29,    28,     1,    41,
       3,     4,    35,    32,     7,     8,     9,    37,    38,    27,
      40,    41,    42,    14,    14,    14,    11,    29,    14,    12,
      25,    15,    32,    25,    15,     4,   130,    25,   134,   155,
      56,   154,    67,    76,    -1,    -1,    -1,    34
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,     4,    44,    45,    46,    83,    11,    83,     0,
       1,    46,    83,     3,     7,     8,     9,     5,     6,     6,
       5,    47,    50,    51,    83,    29,    29,    48,     5,     6,
      12,    18,    19,    21,    22,    41,    70,    72,    73,    74,
      31,    78,    10,     5,    60,    61,    73,     5,    82,    33,
      32,     5,     6,    83,    26,    13,    25,    28,    74,    71,
      72,    78,    78,    49,    74,    61,     5,    32,     1,    16,
      18,    19,    22,    34,    37,    38,    39,    40,    42,    52,
      53,    54,    55,    56,    57,    58,    59,    62,    67,    68,
      69,    70,    75,    76,    77,    79,    80,    81,    82,    71,
      27,     5,    82,    82,    82,    37,    38,    69,    14,    14,
      77,    82,    38,    76,    14,    14,    11,    27,    83,    29,
      78,    17,    19,    20,    23,    24,    26,    29,    35,    35,
      12,    82,    74,    82,    83,    69,    82,    63,    64,    65,
      66,    69,    63,    82,    82,    74,    82,    63,    63,    60,
      15,    15,    15,    52,    32,    25,    29,    30,    13,    64,
      66,    69,    69,    15
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)           \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#define YYLEX	yylex ()

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*-----------------------------.
| Print this symbol on YYOUT.  |
`-----------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yysymprint (FILE* yyout, int yytype, YYSTYPE yyvalue)
#else
yysymprint (yyout, yytype, yyvalue)
    FILE* yyout;
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyout, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyout, yytoknum[yytype], yyvalue);
# endif
    }
  else
    YYFPRINTF (yyout, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyout, ")");
}
#endif /* YYDEBUG. */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yydestruct (int yytype, YYSTYPE yyvalue)
#else
yydestruct (yytype, yyvalue)
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  switch (yytype)
    {
      default:
        break;
    }
}



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of parse errors so far.  */
int yynerrs;


int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with.  */

  if (yychar <= 0)		/* This means end of input.  */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more.  */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

      /* We have to keep this `#if YYDEBUG', since we use variables
	 which are defined only if `YYDEBUG' is set.  */
      YYDPRINTF ((stderr, "Next token is "));
      YYDSYMPRINT ((stderr, yychar1, yylval));
      YYDPRINTF ((stderr, "\n"));
    }

  /* If the proper action on seeing token YYCHAR1 is to reduce or to
     detect an error, take that action.  */
  yyn += yychar1;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yychar1)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];



#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn - 1, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] >= 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif
  switch (yyn)
    {
        case 2:
#line 94 "parser.y"
    {
	       char * comment_str = yyvsp[0] ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (MetaGrammar, comment_node) ;
	       }
	     }
    break;

  case 3:
#line 102 "parser.y"
    {
             DBUGYACC(printf ("One Dcl\n") ;);
             }
    break;

  case 5:
#line 106 "parser.y"
    {printf ("\nLine number: %d\n",yylineno);}
    break;

  case 6:
#line 109 "parser.y"
    {
	       class_found += 1;
	       CurrentClass = xmlNewChild (MetaGrammar, NULL, (xmlChar*)"class", NULL) ;
	       xmlSetProp (CurrentClass, (xmlChar*)"name", (xmlChar*)yyvsp[0]) ;
	       new_class_symb (yyvsp[0], 1, yylineno) ;
	       char * comment_str = yyvsp[-2] ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (CurrentClass, comment_node) ;
	       }
	     }
    break;

  case 7:
#line 121 "parser.y"
    {
	       char * comment_str = yyvsp[0] ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (CurrentClass, comment_node) ;
	       }
	     }
    break;

  case 8:
#line 129 "parser.y"
    {
	       char * comment_str = yyvsp[0] ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (CurrentClass, comment_node) ;
	       }
	     }
    break;

  case 9:
#line 137 "parser.y"
    {
	       /* reinitialiser pour une autre classe */
	       CurrentClass = NULL ;
             }
    break;

  case 10:
#line 142 "parser.y"
    {
	       new_template_macro_symb (yyvsp[0], 1, yylineno) ;
             }
    break;

  case 11:
#line 146 "parser.y"
    {
	       char * comment_str = yyvsp[-5] ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (MetaGrammar, comment_node) ;
	       }
	       xmlNodePtr templateNode = xmlNewNode (NULL, (xmlChar*)"vLib") ;
	       xmlSetProp (templateNode, (xmlChar*)"id", (xmlChar*)yyvsp[-3]) ;
	       xmlAddChild (templateNode, (xmlNodePtr)yyvsp[0]) ;
	       xmlAddChild (MetaGrammar, templateNode) ;
             }
    break;

  case 12:
#line 158 "parser.y"
    {
	       new_path_macro_symb (yyvsp[0], 1, yylineno) ;
             }
    break;

  case 13:
#line 162 "parser.y"
    {
	       char * comment_str = yyvsp[-5] ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (MetaGrammar, comment_node) ;
	       }
	       xmlNodePtr MacroNode = xmlNewNode (NULL, (xmlChar*)"path") ;
	       xmlSetProp (MacroNode, (xmlChar*)"id", (xmlChar*)yyvsp[-3]) ;
	       xmlAddChild (MacroNode, (xmlNodePtr)yyvsp[0]) ;
	       xmlAddChild (MetaGrammar, MacroNode) ;
             }
    break;

  case 14:
#line 174 "parser.y"
    {
	       char * comment_str = yyvsp[-2] ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 xmlAddChild (MetaGrammar, comment_node) ;
	       }
	       xmlNodePtr DisableNode = xmlNewNode (NULL, (xmlChar*)"disable") ;
	       xmlSetProp (DisableNode, (xmlChar*)"name", (xmlChar*)yyvsp[0]) ;
	       xmlAddChild (MetaGrammar, DisableNode) ;
             }
    break;

  case 15:
#line 184 "parser.y"
    {printf ("\nLine number: %d\n",yylineno);}
    break;

  case 17:
#line 188 "parser.y"
    {
	       char * comment_str = yyvsp[0] ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr property_node = (xmlNodePtr)yyvsp[-1] ;
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 DBUGYACC(printf ("Commentaire dans une propriete (1): %s comment_node=%o property_node=%o\n",
				  (xmlChar*)yyvsp[0], comment_node, property_node););
		 xmlAddNextSibling (property_node, comment_node) ;
	       }
	     }
    break;

  case 18:
#line 199 "parser.y"
    {
	       char * comment_str = yyvsp[-1] ;
	       if (comment_str && strlen (comment_str) > 0 && keep_comments) {
		 xmlNodePtr property_node = (xmlNodePtr)yyvsp[-3] ;
		 xmlNodePtr comment_node = xmlNewComment ((xmlChar*)comment_str) ;
		 DBUGYACC(printf ("Commentaire dans une propriete (liste): %s comment_node=%o property_node=%o Proplist=%o\n",
				  (xmlChar*)yyvsp[-1], comment_node, property_node, yyvsp[0]););
		 xmlAddNextSibling (property_node, comment_node) ;
	       }
	     }
    break;

  case 19:
#line 209 "parser.y"
    {printf ("\nLine number: %d\n",yylineno);}
    break;

  case 32:
#line 225 "parser.y"
    {
	       DBUGYACC(printf ("Propriete Heritage: %s\n",yyvsp[0]););
	       xmlNodePtr InheritNode = xmlNewChild (CurrentClass, NULL, (xmlChar*)"super", NULL) ;
	       xmlSetProp (InheritNode, (xmlChar*)"name", (xmlChar*)yyvsp[0]) ;
	       new_class_symb (yyvsp[0], 0, yylineno) ;
	       yyval = (xmlChar*) InheritNode ;
             }
    break;

  case 33:
#line 234 "parser.y"
    {
               DBUGYACC(printf ("Propriete Pere: %s %s\n",yyvsp[-2],yyvsp[0]););
	       xmlNodePtr FatherNode = xmlNewChild (CurrentClass, NULL, (xmlChar*)"relation", NULL) ;
	       xmlSetProp (FatherNode, (xmlChar*)"rel", (xmlChar*)"father") ;
	       xmlSetProp (FatherNode, (xmlChar*)"arg1", (xmlChar*)yyvsp[-2]) ;
	       xmlSetProp (FatherNode, (xmlChar*)"arg2", (xmlChar*)yyvsp[0]) ;
	       yyval = (xmlChar*) FatherNode ;
             }
    break;

  case 34:
#line 244 "parser.y"
    {
               DBUGYACC(printf ("Propriete Anctre: %s %s\n",yyvsp[-2],yyvsp[0]););
	       xmlNodePtr AncestorNode = xmlNewChild (CurrentClass, NULL, (xmlChar*)"relation", NULL) ;
	       xmlSetProp (AncestorNode, (xmlChar*)"rel", (xmlChar*)"dominates") ;
	       xmlSetProp (AncestorNode, (xmlChar*)"arg1", (xmlChar*)yyvsp[-2]) ;
	       xmlSetProp (AncestorNode, (xmlChar*)"arg2", (xmlChar*)yyvsp[0]) ;
	       yyval = (xmlChar*) AncestorNode ;
             }
    break;

  case 35:
#line 254 "parser.y"
    {
	       DBUGYACC(printf ("Propriete Prcdence: %s %s\n",yyvsp[-2],yyvsp[0]););
	       xmlNodePtr PrecNode = xmlNewChild (CurrentClass, NULL, (xmlChar*)"relation", NULL) ;
	       xmlSetProp (PrecNode, (xmlChar*)"rel", (xmlChar*)"precedes") ;
	       xmlSetProp (PrecNode, (xmlChar*)"arg1", (xmlChar*)yyvsp[-2]) ;
	       xmlSetProp (PrecNode, (xmlChar*)"arg2", (xmlChar*)yyvsp[0]) ;
	       yyval = (xmlChar*) PrecNode ;
             }
    break;

  case 36:
#line 264 "parser.y"
    {
	       DBUGYACC(printf ("Propriete Equality: %s %s\n",yyvsp[-2],yyvsp[0]););
	       xmlNodePtr PrecNode = xmlNewChild (CurrentClass, NULL, (xmlChar*)"relation", NULL) ;
	       xmlSetProp (PrecNode, (xmlChar*)"rel", (xmlChar*)"equals") ;
	       xmlSetProp (PrecNode, (xmlChar*)"arg1", (xmlChar*)yyvsp[-2]) ;
	       xmlSetProp (PrecNode, (xmlChar*)"arg2", (xmlChar*)yyvsp[0]) ;
	       yyval = (xmlChar*) PrecNode ;
             }
    break;

  case 37:
#line 276 "parser.y"
    {
	       DBUGYACC(printf ("Propriete desc:%s %o\n",yyvsp[-2],yyvsp[-2]););
	       xmlNodePtr DescNode = xmlNewChild (CurrentClass, NULL,
						  (xmlChar*)"description", NULL) ;
	       xmlAddChild (DescNode, (xmlNodePtr) yyvsp[-2]) ;
	       yyval = (xmlChar*) DescNode ;
             }
    break;

  case 38:
#line 285 "parser.y"
    {
	       xmlNodePtr FSNode = xmlNewNode (NULL, (xmlChar*)"fs") ;
	       DBUGYACC(printf ("Features : liste vide %o\n", FSNode););
	       yyval = (char*) FSNode ;
             }
    break;

  case 39:
#line 291 "parser.y"
    {
	       xmlNodePtr FNode = (xmlNodePtr) yyvsp[0] ;
	       xmlNodePtr FSNode = xmlNewNode (NULL, (xmlChar*)"fs") ;
	       DBUGYACC(printf ("Features : F %o %o\n", yyvsp[0], FSNode););
	       xmlAddChild (FSNode, FNode) ;
	       yyval = (char*) FSNode ;
             }
    break;

  case 40:
#line 299 "parser.y"
    {
	       xmlNodePtr FNode = (xmlNodePtr) yyvsp[0] ;
	       xmlNodePtr FSNode = (xmlNodePtr) yyvsp[-2] ;
	       DBUGYACC(printf ("Features : F FS %o %o %o\n", yyvsp[0], yyvsp[-1], FSNode););
	       xmlAddChild (FSNode, FNode) ;
	       yyval = (char*) FSNode ;
             }
    break;

  case 41:
#line 308 "parser.y"
    {
	       xmlNodePtr FNode = xmlNewNode (NULL, (xmlChar*)"f") ;
	       DBUGYACC(printf ("Feature %s %o %o\n", yyvsp[-2], yyvsp[0], FNode););
	       xmlSetProp (FNode, (xmlChar*)"name", (xmlChar*)yyvsp[-2]) ;
	       xmlAddChild (FNode, (xmlNodePtr)yyvsp[0]) ;
	       yyval = (char*) FNode ;
             }
    break;

  case 42:
#line 318 "parser.y"
    { 
               xmlNodePtr GuardNode = (xmlNodePtr) yyvsp[0];
               xmlSetProp (GuardNode, (xmlChar*)"rel", (xmlChar *) "+");
               xmlSetProp (GuardNode, (xmlChar*)"name", (xmlChar *) yyvsp[-2]);
               xmlAddChild (CurrentClass, GuardNode) ;
	       DBUGYACC(printf("Guard: GuardNode=%o %s\n",GuardNode, yyvsp[-2]););
	       yyval = (char*) GuardNode ;
             }
    break;

  case 43:
#line 327 "parser.y"
    { 
               xmlNodePtr GuardNode = (xmlNodePtr) yyvsp[0];
               xmlSetProp (GuardNode, (xmlChar*)"rel", (xmlChar *) "-");
               xmlSetProp (GuardNode, (xmlChar*)"name", (xmlChar *) yyvsp[-2]);
               xmlAddChild (CurrentClass, GuardNode) ;
	       DBUGYACC(printf("Guard: GuardNode=%o ~%s\n",GuardNode,yyvsp[-2]););
	       yyval = (char*) GuardNode ;
             }
    break;

  case 44:
#line 336 "parser.y"
    {
               xmlNodePtr GuardNode = (xmlNodePtr) yyvsp[0];
               xmlSetProp (GuardNode, (xmlChar*)"rel", (xmlChar *) "+");
               xmlSetProp (GuardNode, (xmlChar*)"name", (xmlChar *) yyvsp[-2]);
               xmlAddChild (CurrentClass, GuardNode) ;
               xmlNodePtr FailNode = xmlNewNode(NULL, (xmlChar*)"guard");
               xmlSetProp (FailNode, (xmlChar*)"rel", (xmlChar *) "-");
               xmlSetProp (FailNode, (xmlChar*)"name", (xmlChar *) yyvsp[-2]);
               xmlAddChild (CurrentClass, FailNode) ;
	       DBUGYACC(printf("Guard: GuardNode=%o %s\n",GuardNode, yyvsp[-2]););
	       yyval = (char*) GuardNode ;
             }
    break;

  case 45:
#line 349 "parser.y"
    {
               xmlNodePtr GuardNode = (xmlNodePtr) yyvsp[0];
               xmlSetProp (GuardNode, (xmlChar*)"rel", (xmlChar *) "++");
               xmlSetProp (GuardNode, (xmlChar*)"name", (xmlChar *) yyvsp[-2]);
               xmlAddChild (CurrentClass, GuardNode) ;
               xmlNodePtr FailNode = xmlNewNode(NULL, (xmlChar*)"guard");
               xmlSetProp (FailNode, (xmlChar*)"rel", (xmlChar *) "-");
               xmlSetProp (FailNode, (xmlChar*)"name", (xmlChar *) yyvsp[-2]);
               xmlAddChild (CurrentClass, FailNode) ;
	       DBUGYACC(printf("Guard: GuardNode=%o %s\n",GuardNode, yyvsp[-2]););
	       yyval = (char*) GuardNode ;
             }
    break;

  case 46:
#line 364 "parser.y"
    { 
                 xmlNodePtr GuardNode = xmlNewNode (NULL, (xmlChar*)"guard");
                 xmlAddChild (GuardNode,(xmlNodePtr)yyvsp[0]);
		 DBUGYACC(printf("EqAlt: GuardNode=%o\n",GuardNode););
                 yyval = (char *)GuardNode;
             }
    break;

  case 47:
#line 371 "parser.y"
    {    xmlNodePtr GuardNode = (xmlNodePtr) yyvsp[-2];
	          xmlAddChild (GuardNode,(xmlNodePtr) yyvsp[0]);
		  DBUGYACC(printf("EqAlt: GuardNode=%o\n",GuardNode););
		  yyval = yyvsp[-2];
	     }
    break;

  case 48:
#line 377 "parser.y"
    { yyval = yyvsp[0]; }
    break;

  case 49:
#line 378 "parser.y"
    {
         xmlNodePtr SeqGuardNode = (xmlNodePtr) yyvsp[-2];
         xmlAddChild (SeqGuardNode,(xmlNodePtr) yyvsp[0]);
	 DBUGYACC(printf("EqSeq: SeqGuardNode=%o\n",SeqGuardNode););
         yyval = yyvsp[-2];
     }
    break;

  case 50:
#line 385 "parser.y"
    {
       xmlNodePtr SeqGuardNode = xmlNewNode (NULL, (xmlChar*)"and");
       xmlAddChild (SeqGuardNode,(xmlNodePtr)yyvsp[0]);
       DBUGYACC(printf ("EqSeq1 (1): SeqGuardNode=%o %o\n", SeqGuardNode));
       yyval = (char *)SeqGuardNode;
              }
    break;

  case 51:
#line 392 "parser.y"
    {
                  xmlNodePtr SeqGuardNode = (xmlNodePtr) yyvsp[-2];
	          xmlAddChild (SeqGuardNode,(xmlNodePtr) yyvsp[0]);
		  DBUGYACC(printf ("EqSeq1: SeqGuardNode=%o %o\n", SeqGuardNode, yyvsp[0]));
		  yyval = yyvsp[-2];
              }
    break;

  case 52:
#line 400 "parser.y"
    { 
               xmlNodePtr EqNode = xmlNewNode (NULL, (xmlChar*)"equation");
               xmlAddChild (EqNode, (xmlNodePtr) yyvsp[-2]);
               xmlAddChild (EqNode, (xmlNodePtr) yyvsp[0]);
               yyval = (char *)EqNode;
	       DBUGYACC(printf ("EqElem: EqNode=%o\n", EqNode));
             }
    break;

  case 53:
#line 408 "parser.y"
    { 
               xmlNodePtr EqNode = xmlNewNode (NULL, (xmlChar*)"equation");
               xmlSetProp (EqNode, (xmlChar*)"default", (xmlChar *) "+");
               xmlAddChild (EqNode, (xmlNodePtr) yyvsp[-2]);
               xmlAddChild (EqNode, (xmlNodePtr) yyvsp[0]);
               yyval = (char *)EqNode;
	       DBUGYACC(printf ("EqElem: EqNode=%o\n", EqNode));
             }
    break;

  case 54:
#line 419 "parser.y"
    { 
               xmlNodePtr AtomicNode = xmlNewNode (NULL, (xmlChar*)"atomic");
               xmlAddChild (AtomicNode, (xmlNodePtr) yyvsp[0]);
               xmlAddChild (CurrentClass, AtomicNode) ;
               yyval = (char *)AtomicNode;
             }
    break;

  case 55:
#line 427 "parser.y"
    {
	       xmlNodePtr EquationNode = xmlNewNode (NULL, (xmlChar*)"equation") ;
	       xmlNodePtr Root1 = (xmlNodePtr)yyvsp[-2] ;
	       xmlNodePtr Root2 = (xmlNodePtr)yyvsp[0] ;
	       xmlAddChild (EquationNode, Root1) ;
	       xmlAddChild (EquationNode, Root2) ;
	       xmlAddChild (CurrentClass, EquationNode) ;
	       DBUGYACC(printf ("Propriete Equation : Equation_node=%o Root1=%o Root2=%o\n", EquationNode, yyvsp[-2], yyvsp[0]););
               yyval = (char *)EquationNode ;
             }
    break;

  case 56:
#line 439 "parser.y"
    {
	       xmlNodePtr RootNode = (xmlNodePtr)yyvsp[-1] ;
	       xmlAddChild (RootNode, (xmlNodePtr)yyvsp[0]) ;
	       DBUGYACC(printf ("EqTerm: RootNode:%o Path:%o\n",RootNode,yyvsp[0]););
	       yyval = (char*) RootNode ;
             }
    break;

  case 57:
#line 446 "parser.y"
    {
	       xmlNodePtr Node = xmlNewNode (NULL, (xmlChar*)"value") ;
	       xmlAddChild (Node, (xmlNodePtr)yyvsp[-1]) ;
	       DBUGYACC(printf ("EqTerm: Node:%o Value:%o\n",Node,yyvsp[-1]););
	       yyval = (char*) Node ;
             }
    break;

  case 58:
#line 454 "parser.y"
    {
	       xmlNodePtr VarNode = xmlNewNode (NULL, (xmlChar*)"var") ;
	       xmlSetProp (VarNode, (xmlChar*)"name", (xmlChar*)yyvsp[0]) ;
	       yyval = (char*) VarNode ;
           }
    break;

  case 59:
#line 461 "parser.y"
    {
                 xmlNodePtr AltNode = xmlNewNode (NULL, (xmlChar*)"vAlt") ;
                 xmlAddChild (AltNode, (xmlNodePtr) yyvsp[0]) ;
                 yyval = (char*) AltNode ;
	     }
    break;

  case 60:
#line 467 "parser.y"
    {
	       xmlNodePtr AltNode = (xmlNodePtr)yyvsp[0] ;
	       xmlNodePtr FirstAltNode = AltNode->xmlChildrenNode ;
	       xmlAddPrevSibling (FirstAltNode, (xmlNodePtr)yyvsp[-2]) ;
	       yyval = (char*) AltNode ;
	     }
    break;

  case 61:
#line 474 "parser.y"
    {
	       xmlNodePtr VarNode = xmlNewNode (NULL, (xmlChar*)"symbol") ;
	       xmlSetProp (VarNode, (xmlChar*)"value", (xmlChar*)yyvsp[0]) ;
	       yyval = (char*) VarNode ;
	     }
    break;

  case 62:
#line 481 "parser.y"
    {
	       xmlNodePtr VarNode = xmlNewNode (NULL, (xmlChar*)"symbol") ;
	       xmlSetProp (VarNode, (xmlChar*)"value", (xmlChar*)"*") ;
	       yyval = (char*) VarNode ;
	     }
    break;

  case 63:
#line 487 "parser.y"
    {
	       yyval = (char*) xmlNewNode (NULL, (xmlChar*)"plus") ;
	     }
    break;

  case 64:
#line 491 "parser.y"
    {
	       yyval = (char*) xmlNewNode (NULL, (xmlChar*)"minus") ;
	     }
    break;

  case 65:
#line 495 "parser.y"
    { yyval = yyvsp[0]; }
    break;

  case 66:
#line 497 "parser.y"
    {
	       xmlNodePtr AltNode = (xmlNodePtr)yyvsp[0] ;
	       xmlNodePtr FirstAltNode = AltNode->xmlChildrenNode ;
	       xmlAddPrevSibling (FirstAltNode, (xmlNodePtr) yyvsp[-2]) ;
	       yyval = (char*) AltNode ;
	     }
    break;

  case 67:
#line 504 "parser.y"
    { yyval = yyvsp[0]; }
    break;

  case 68:
#line 506 "parser.y"
    {
	       xmlNodePtr NotNode = xmlNewNode (NULL, (xmlChar*)"not") ;
               xmlAddChild(NotNode, (xmlNodePtr)yyvsp[0]);
	       yyval = (char*) NotNode ;
	     }
    break;

  case 69:
#line 512 "parser.y"
    {
	       yyval = yyvsp[0];
	     }
    break;

  case 70:
#line 516 "parser.y"
    {
                 xmlNodePtr VarNode = (xmlNodePtr) yyvsp[-2];
                 xmlAddChild (VarNode, (xmlNodePtr)yyvsp[0]) ;
                 yyval = (char*) VarNode ;
	     }
    break;

  case 71:
#line 522 "parser.y"
    {
	       xmlNodePtr FNode = xmlNewNode (NULL, (xmlChar*)"fs") ;
	       xmlSetProp (FNode, (xmlChar*)"idref", (xmlChar*)yyvsp[0]) ;
	       yyval = (char*) FNode ;
             }
    break;

  case 72:
#line 528 "parser.y"
    {
	       yyval = (char*) yyvsp[-1] ;
             }
    break;

  case 74:
#line 534 "parser.y"
    {
	      xmlNodePtr Node = (xmlNodePtr) yyvsp[0] ;
	      xmlSetProp (Node, (xmlChar*)"optional", (xmlChar*)"yes") ;
	      yyval = (char*) Node ;
	    }
    break;

  case 75:
#line 541 "parser.y"
    {
	      xmlNodePtr Node = (xmlNodePtr) yyvsp[0] ;
	      xmlSetProp (Node, (xmlChar*)"virtual", (xmlChar*)"yes") ;
	      yyval = (char*) Node ;
	    }
    break;

  case 76:
#line 547 "parser.y"
    {
	      xmlNodePtr Node = (xmlNodePtr) yyvsp[0] ;
	      xmlSetProp (Node, (xmlChar*)"virtual", (xmlChar*)"no") ;
	      yyval = (char *) Node ;
	    }
    break;

  case 77:
#line 554 "parser.y"
    {
	       DBUGYACC (printf ("Node %s\n",yyvsp[-2]););
	       xmlNodePtr Node = xmlNewNode (NULL, (xmlChar*)"node") ;
	       xmlSetProp (Node, (xmlChar*)"name", (xmlChar*)yyvsp[-2]) ;
//               xmlSetProp (Node, (xmlChar*)"virtual", (xmlChar*)"yes") ;
	       xmlAddChild (Node, (xmlNodePtr)yyvsp[0]) ;
	       xmlAddChild (CurrentClass, Node) ;
               yyval= (char *) Node;
           }
    break;

  case 78:
#line 565 "parser.y"
    {
	       xmlNodePtr PathNode = NULL ;
	       yyval = (char*) PathNode ;
	     }
    break;

  case 79:
#line 570 "parser.y"
    {
	       xmlNodePtr PathNode = xmlNewNode (NULL, (xmlChar*)"f") ;
	       xmlSetProp (PathNode, (xmlChar*)"name", (xmlChar*)yyvsp[-1]) ;
	       if (yyvsp[0] != NULL) {
		 xmlAddChild (PathNode, (xmlNodePtr)yyvsp[0]) ;
	       }
	       yyval = (char*) PathNode ;
	     }
    break;

  case 80:
#line 579 "parser.y"
    {
	       xmlNodePtr PathNode = xmlNewNode (NULL, (xmlChar*)"path") ;
	       xmlSetProp (PathNode, (xmlChar*)"idref", (xmlChar*)yyvsp[-1]) ;
	       if (yyvsp[0] != NULL) {
		 xmlAddChild (PathNode, (xmlNodePtr)yyvsp[0]) ;
	       }
	       new_path_macro_symb (yyvsp[-1], 0, yylineno) ;
	       yyval = (char*) PathNode ;
	     }
    break;

  case 81:
#line 590 "parser.y"
    {
	       xmlNodePtr Node = xmlNewNode (NULL, (xmlChar*)"description") ;
	       yyval = (char*) Node ;
	     }
    break;

  case 82:
#line 595 "parser.y"
    {
	       xmlNodePtr Node = xmlNewNode (NULL, (xmlChar*)"father") ;
	       xmlSetProp (Node, (xmlChar*)"name", (xmlChar*)yyvsp[-1]) ;
	       yyval = (char*) Node ;
	     }
    break;

  case 83:
#line 601 "parser.y"
    {
	       xmlNodePtr Node = xmlNewNode (NULL, (xmlChar*)"node") ;
	       xmlSetProp (Node, (xmlChar*)"name", (xmlChar*)yyvsp[-1]) ;
	       yyval = (char*) Node ;
	     }
    break;

  case 84:
#line 607 "parser.y"
    { yyval = yyvsp[0]; }
    break;

  case 85:
#line 610 "parser.y"
    {
	       DBUGYACC(printf ("Propriete Needs:%s\n",yyvsp[-1]););
	       xmlNodePtr Node = xmlNewChild (CurrentClass, NULL, (xmlChar*)"needs", NULL) ;
	       xmlSetProp (Node, (xmlChar*)"name", (xmlChar*)yyvsp[0]) ;
	       yyval = (char*) Node ;
             }
    break;

  case 86:
#line 618 "parser.y"
    {
	       DBUGYACC(printf ("Propriete Provides:%s\n",yyvsp[-1]););
	       xmlNodePtr Node = xmlNewChild (CurrentClass, NULL, (xmlChar*)"provides", NULL) ;
	       xmlSetProp (Node, (xmlChar*)"name", (xmlChar*)yyvsp[0]) ;
	       yyval = (char*) Node ;
             }
    break;

  case 87:
#line 626 "parser.y"
    {
	       yyval = (char*) yyvsp[0] ;
             }
    break;

  case 88:
#line 630 "parser.y"
    {
	       char * str1 = (char*) yyvsp[-2] ;
	       char * str2 = (char*) yyvsp[0] ;
	       char * newstr = (char*) calloc (strlen(str1) + 2 + strlen(str2),
					       sizeof (char)) ;
	       sprintf (newstr, "%s:%s", str1, str2) ;
	       yyval = newstr ;
             }
    break;

  case 89:
#line 639 "parser.y"
    { yyval = NULL ; }
    break;

  case 90:
#line 641 "parser.y"
    {
	       DBUGYACC(printf ("Doc:\t%s\n", yyvsp[-1]););
	       char * str1 = yyvsp[-1]; char * str2 = yyvsp[0] ;
	       yyval = cp_str (str1,str2) ;
             }
    break;


    }

/* Line 1016 of /usr/share/bison/yacc.c.  */
#line 1958 "parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyssp > yyss)
	    {
	      YYDPRINTF ((stderr, "Error: popping "));
	      YYDSYMPRINT ((stderr,
			    yystos[*yyssp],
			    *yyvsp));
	      YYDPRINTF ((stderr, "\n"));
	      yydestruct (yystos[*yyssp], *yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yydestruct (yychar1, yylval);
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDPRINTF ((stderr, "Error: popping "));
      YYDSYMPRINT ((stderr,
		    yystos[*yyssp], *yyvsp));
      YYDPRINTF ((stderr, "\n"));

      yydestruct (yystos[yystate], *yyvsp);
      yyvsp--;
      yystate = *--yyssp;


#if YYDEBUG
      if (yydebug)
	{
	  short *yyssp1 = yyss - 1;
	  YYFPRINTF (stderr, "Error: state stack now");
	  while (yyssp1 != yyssp)
	    YYFPRINTF (stderr, " %d", *++yyssp1);
	  YYFPRINTF (stderr, "\n");
	}
#endif
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 93 "parser.y"

